#include<iostream>

void matprod(double ** M1, double ** M2, unsigned int dim);
void matprod(int ** M1, int ** M2, unsigned int dim);

using namespace std;

int main(){
  double matrix1[3][3]={{1,0,0},{0,1,0},{0,0,1}};
  double matrix2[3][3]={{9,8,7},{6,5,4},{3,2,1}};
  size_t dim =3;
  double ** mat1, ** mat2;
  mat1 = new double * [dim];
  mat2 = new double * [dim];
  for(size_t i=0; i!=dim; ++i){
    mat1[i]= new double  [dim];
    mat2[i] = new double  [dim];
    for(size_t j=0; j!=dim; ++j){
      mat1[i][j]=matrix1[i][j];
      mat2[i][j]=matrix2[i][j];
    }
  }

  matprod(mat1,mat2,dim);
  cout << endl;

  for(size_t i=0; i!=dim; ++i){
    delete [] mat1[i];
    delete [] mat2[i];
  }
  delete [] mat1;
  delete [] mat2;

  int imatrix1[3][3]={{1,0,0},{0,1,0},{0,0,1}};
  int imatrix2[3][3]={{9,8,7},{6,5,4},{3,2,1}};
  int ** imat1, ** imat2;
  imat1 = new int * [dim];
  imat2 = new int * [dim];
  for(size_t i=0; i!=dim; ++i){
    imat1[i]= new int  [dim];
    imat2[i] = new int  [dim];
    for(size_t j=0; j!=dim; ++j){
      imat1[i][j]=imatrix1[i][j];
      imat2[i][j]=imatrix2[i][j];
    }
  }

  matprod(imat1,imat2,dim);
  for(size_t i=0; i!=dim; ++i){
    delete [] imat1[i];
    delete [] imat2[i];
  }
  delete [] imat1;
  delete [] imat2;


}
